--------------------------------------------------------------------------------
-- Health Drain by Holzchopf
-- v1.2 - 28 Sep 2011	- Updated hierarchy
-- v1.1 - 30 Jul 2010	- New icon
--------------------------------------------------------------------------------

-- setup
if holzchopf==nil then holzchopf={} end
holzchopf.healthdrain={}

-- load ressources
holzchopf.healthdrain.gfx=loadgfx("holzchopf/healthdrain.png")
setmidhandle(holzchopf.healthdrain.gfx)
holzchopf.healthdrain.sfx=loadsfx("diaboliclaugh.ogg")

--------------------------------------------------------------------------------
-- Weapon
--------------------------------------------------------------------------------
holzchopf.healthdrain.id=addweapon("holzchopf.healthdrain","Health Drain", holzchopf.healthdrain.gfx, 0, 3)

function holzchopf.healthdrain.draw()
	if weapon_shots==0 then
		hudpositioning(pos_invisible)
		hudinfo("Click near player to steal his health!")
	end
end

function holzchopf.healthdrain.attack(attack)
	if (weapon_shots==0) and (weapon_position==1) then
		-- disable weapon switching
		useweapon(0)
		weapon_shots=1
		-- find closest player
		closest=10000
		targetid=0
		players=playertable(3,0)
		for i=1,#players,1 do
			dist=math.sqrt((weapon_x-getplayerx(players[i]))^2 + (weapon_y-getplayery(players[i]))^2)
			if dist<closest then
				closest=dist
				targetid=players[i]
			end
		end
		-- swap health
		health0=getplayerhealth(0)
		health1=getplayerhealth(targetid)
		if health1>health0 then
			playerheal(0,health1-health0)
			playerdamage(targetid,health1-health0)
		else
			playerheal(targetid,health1-health0)
			playerdamage(0,health1-health0)
		end
		-- effects
		playsound(holzchopf.healthdrain.sfx)
		x=getplayerx(0)
		y=getplayery(0)+3
		particle(p_muzzle,x,y)
		particlesize(1,1)
		particlecolor(0,255,0)
		particlealpha(1.0)
		particlefadealpha(0.01)
		particle(p_muzzle,x,y)
		particlesize(1,2)
		particlecolor(0,255,0)
		particlealpha(1.0)
		particlefadealpha(0.02)
		particlerotation(0)
		for j=1,15,1 do
			particle(p_lightpuff,x-10.0+math.random()*20.0,y+math.random()*10.0)
			particlesize(3.0,3.0)
			particlecolor(0,255,0)
			particlespeed(0,math.random(2,15)*-0.1)
			particlefadealpha(0.01)
		end
		x=getplayerx(targetid)
		y=getplayery(targetid)+3
		particle(p_muzzle,x,y)
		particlesize(1,1)
		particlecolor(255,0,0)
		particlealpha(1.0)
		particlefadealpha(0.01)
		particle(p_muzzle,x,y)
		particlesize(1,2)
		particlecolor(255,0,0)
		particlealpha(1.0)
		particlefadealpha(0.02)
		particlerotation(0)
		for j=1,15,1 do
			particle(p_lightpuff,x-10.0+math.random()*20.0,y+math.random()*10.0)
			particlesize(3.0,3.0)
			particlecolor(255,0,0)
			particlespeed(0,math.random(2,15)*-0.1)
			particlefadealpha(0.01)
		end
		-- End Turn
		endturn()
	end
end